
-- return the window size
getWindowSize = getWindowSize or function()
	return 650, 125
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()

	-- constants
	local kKnobSpace = 43
	local kWideTextW = 40

	-- make groups and knobs
	--
	
	local x = 0

	theKnobRenderer = smallKnobRenderer

	targetGroup = group( "Target" )
	x = 0
	labelledDropDown( targetGroup, "Target Hardware", "Hardware",	x, 0 )
	x = x + kDropdownW + pad
	labelledDropDown( targetGroup, "Target Channel", "Channel",		x, 0 )
	x = x + kDropdownW + pad

	inputsGroup = group( "Inputs" )
	local kInputsW = 40
	local kInputsY = kTextFieldH + 20
	x = 0
	labelledDropDown( inputsGroup, "Input Thru", "Thru",		x, kInputsY, kInputsW )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 1", "1",		x, kInputsY, kInputsW )
	x = x + kInputsW + 10
	labelledDropDown( inputsGroup, "Input 2", "2",		x, kInputsY, kInputsW )
	x = x + kInputsW + 10

	interfaceGroup = group( "Interface" )
	x = 0
	labelledDropDown( interfaceGroup, "Interface Category", "Category",		x, 0 )

	oscGroup = group( "OSC" )
	smallKnobAndTextField( oscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	oscGroup:setVisible( false )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase

	targetGroup:setPosition( x, y, true )
	x = x + targetGroup:width() + pad

	inputsGroup:setPosition( x, y, true )
	x = x + inputsGroup:width() + pad

	interfaceGroup:setPosition( x, y, true )
	x = x + interfaceGroup:width() + pad

	-- add directly positioned objects
	--

end		-- of createUI()
